;-- TIME_STAMP   2020-06-28 18:13:24   v 0.1

#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_AU3Check_Parameters=-q -d -w 1 -w 2 -w 3 -w- 4 -w 5 -w 6 -w- 7
#AutoIt3Wrapper_Change2CUI=y
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****

#RequireAdmin

#include <Array.au3>

;~ Opt('MustDeclareVars', 1)

Global Const $g_sIP_Pattern = '(\d+\.\d+\.\d+\.\d+)'
Global Const $g_sMAC_Pattern = '([0-9A-F]{2}-[0-9A-F]{2}-[0-9A-F]{2}-[0-9A-F]{2}-[0-9A-F]{2}-[0-9A-F]{2}|[0-9A-F]{2}:[0-9A-F]{2}:[0-9A-F]{2}:[0-9A-F]{2}:[0-9A-F]{2}:[0-9A-F]{2})'

TCPStartup()
OnAutoItExitRegister('_Exit')

_ScanArpCache()

Func _ScanArpCache()
	Local $sFind, $iPID, $sOutput, $sMAC, $sIP, $sSubNet, $iStart = 1, $iEnd = 254, $iWait = 0, $iAlive, $iScan, $iIndex, $aRx, $aFilter[0][2], $hTimer = TimerInit()

	; Ab und an wird folgender Fehler gemeldet: "Fehler beim Löschen des ARP-Eintrags: Falscher Parameter."
	; Deshalb leiten wir die Ausgabe nach nul um.
	RunWait('<nul arp -d *', '', @SW_HIDE) ; ARP-Cache leeren (erfordert erhöhte Rechte!)

	_GetCmdline($sMAC, $sIP, $sSubNet, $iStart, $iEnd, $iWait)

	Switch True
		Case $sMAC
			$sFind = $sMAC
		Case $sIP
			$sFind = $sIP
			Ping($sIP, $iWait)
		Case $sSubNet
			_PingSubNet($sSubNet, $iStart, $iEnd, $iWait)
		Case Else
			$sFind = ''
	EndSwitch

	Sleep(250) ; Warten, bis ARP-Cache wieder gefüllt ist.

	If $sFind Then
		$iPID = Run(@ComSpec & ' /C arp -a|find /I "' & $sFind & '"', '', @SW_HIDE, $STDOUT_CHILD)
	Else
		$iPID = Run(@ComSpec & ' /C arp -a', '', @SW_HIDE, $STDOUT_CHILD)
	EndIf
	ProcessWaitClose($iPID)
	$sOutput = StdoutRead($iPID)

	If $sOutput Then
		If $sSubNet Then
			$aRx = StringRegExp($sOutput, '(?im)(.+)\R', 3)
;~ 			ConsoleWrite("@@_Debug_line" & @TAB & @TAB & @ScriptLineNumber & "   var: $iStart --> " & $iStart & @LF)
;~ 			ConsoleWrite("@@_Debug_line" & @TAB & @TAB & @ScriptLineNumber & "   var: $iEnd   --> " & $iEnd & @LF)
			For $i = $iStart To $iEnd Step 1
				$iIndex = _ArraySearch($aRx, '\h*\Q' & $sSubNet & '.' & $i & '\E\h+.+[^\R]', 2, 0, 0, 3)
				If $iIndex > -1 Then
;~ 					ConsoleWrite('! ' & $iIndex & ' ' & $aRx[$iIndex] & ' <<<=== ' & $sSubNet & '.' & $i & @CRLF)
					_ArrayAdd($aFilter, $aRx[$iIndex])
					_ArrayDelete($aRx, $iIndex)
				EndIf
			Next
;~ 			$aFilter = _ArrayUnique($aFilter, 0, 0, 0, $ARRAYUNIQUE_NOCOUNT)
;~ 			_ArrayDisplay($aFilter, '$aFilter')
		ElseIf $sIP Then
			$aRx = StringRegExp($sOutput, '(?im).+\Q' & $sIP & '\E.+[^\R]', 3)
			If IsArray($aRx) Then _ArrayAdd($aFilter, $aRx[0])
		ElseIf $sMAC Then
			$aRx = StringRegExp($sOutput, '(?im).+\Q' & $sMAC & $i & '\E.+[^\R]', 3)
			If IsArray($aRx) Then _ArrayAdd($aFilter, $aRx[0])
		EndIf


		; output how many hosts we scanned and how long and how many hosts were alive
		$iAlive = UBound($aFilter)
		$iScan = $iEnd - $iStart + 1
		ConsoleWrite("Scanned " & $iScan & " address" & ($iScan > 1 ? "es" : "") & " in " & Round(TimerDiff($hTimer) / 1000, 2) & " seconds and found " & $iAlive & " alive host" & ($iAlive > 1 ? "s" : "") & "." & @CRLF)

;~ 		_ArrayDisplay($aFilter, '$aFilter')
		If UBound($aFilter) Then
			Local $sSpacer = '--------------------------------------------------------------' & @CRLF
			ConsoleWrite($sSpacer & _ArrayToString($aFilter, '', -1, -1, @CRLF) & @CRLF & $sSpacer)
		Else
			ConsoleWrite($sFind & ' nicht gefunden!' & @CRLF)
		EndIf
	Else
		ConsoleWrite($sFind & ' nicht gefunden!' & @CRLF)
	EndIf
EndFunc   ;==>_ScanArpCache

Func _GetCmdline(ByRef $sMAC, ByRef $sIP, ByRef $sSubNet, ByRef $iStart, ByRef $iEnd, ByRef $iWait)
	Local $vParam
	If $CMDLINE[0] Then
		For $i = 1 To $CMDLINE[0]
			Switch StringLeft($CMDLINE[$i], 3)
				Case '/?'
					MsgBox(0x40000, @ScriptName & ' Help', _
							'Switches are:' & @CRLF _
							 & @CRLF & '/M:<MAC-Address>' _
							 & @CRLF & @TAB & 'Example: /M:d8-80-39-e5-41-d7' _
							 & @CRLF & '/H:<HostName>' _
							 & @CRLF & @TAB & 'Example: /H:Galaxy-S7' _
							 & @CRLF & '/I:<IP-Address>' _
							 & @CRLF & @TAB & 'Example: /I:192.168.178.33' _
							 & @CRLF & '/S:<SubNet>' _
							 & @CRLF & @TAB & 'Example: /S:192.168.178.0' _
							 & @CRLF & '/F:<Start> (only with /S)' _
							 & @CRLF & @TAB & 'Example: /F:33' _
							 & @CRLF & '/T:<End> (only with /S)' _
							 & @CRLF & @TAB & 'Example: /T:36' _
							 & @CRLF & '/W:<Wait> ms (only with /S)' _
							 & @CRLF & @TAB & 'Example: /W:10')
					Exit
				Case '/M:'
					$vParam = StringReplace(StringMid($CMDLINE[$i], 4), ':', '-')
					If _IsMAC($vParam) Then $sMAC = $vParam
				Case '/H:'
					$vParam = TCPNameToIP(StringMid($CMDLINE[$i], 4))
					If _IsIPv4($vParam) Then
						$sIP = $vParam
						$iStart = StringRegExpReplace($vParam, '^(?:\d+\.\d+\.\d+)\.(\d+)$', '\1')
						$iEnd = $iStart
					EndIf
				Case '/I:'
					$vParam = StringMid($CMDLINE[$i], 4)
					If _IsIPv4($vParam) Then
						$sIP = $vParam
						$iStart = StringRegExpReplace($vParam, '^(?:\d+\.\d+\.\d+)\.(\d+)$', '\1')
						$iEnd = $iStart
					EndIf
					Case '/S:'
					$vParam = StringMid($CMDLINE[$i], 4)
					If StringRegExpReplace($vParam, '^(?:\d+\.){3}(\d+)', '\1') <> 0 Then Exit ConsoleWrite($vParam & ' ist kein SubNet!' & @CRLF)
					If _IsIPv4($vParam) Then $sSubNet = StringRegExpReplace($vParam, '^(\d+\.\d+\.\d+).*$', '\1')
					If @extended <> 1 Then Exit ConsoleWrite($vParam & ' ist kein SubNet!' & @CRLF)
				Case '/F:'
					$iStart = StringMid($CMDLINE[$i], 4)
					If $iStart < 1 Or $iStart > 254 Then $iStart = 1
				Case '/T:'
					$iEnd = StringMid($CMDLINE[$i], 4)
					If $iEnd < $iStart Or $iEnd > 254 Then $iEnd = 254
				Case '/W:'
					$iWait = StringMid($CMDLINE[$i], 4)
					If $iWait < 1 Then $iWait = 1
				Case Else
					_Usage()
			EndSwitch
		Next
	Else
		_Usage()
	EndIf
EndFunc   ;==>_GetCmdline

Func _Usage()
	MsgBox(0x40000, 'Incorrect switch used', _
			'Command used:' & @CRLF & $CMDLINERAW & @CRLF & _
			@CRLF & 'Syntax:' & @CRLF & _
			@ScriptName & ' <MAC-Address>|<HostName>|<IP-Address> [<Wait>]' & @CRLF & _
			@ScriptName & ' <SubNet> [<Start>] [<End>] [<Wait>]' & @CRLF & _
			@CRLF & 'Use /? for the switches available.')
	Exit
EndFunc   ;==>_Usage

; Sorgt dafür, dass die angepingten IPs inkl. MAC im ARP-Cache landen, wenn das Gerät erreichbar ist.
Func _PingSubNet($sSubNet, $iStart = 1, $iEnd = 254, $iWait = 0)
;~ 	ConsoleWrite('_PingSubNet - start!' & @CRLF)
;~ 	RunWait(@ComSpec & StringFormat(' /C FOR /L %%L IN (%i,1,%i) DO @ping -4 -n 1 -w %i %s.%%L >nul', $iStart, $iEnd, $iWait, $sSubNet), '', @SW_HIDE)
;~ 	RunWait(@ComSpec & StringFormat(' /C FOR /L %%L IN (%i,1,%i) DO @ping -4 -n 1 -w %i %s.%%L', $iStart, $iEnd, $iWait, $sSubNet), '', @SW_SHOW)
	RunWait(@ComSpec & StringFormat(' /C FOR /L %%L IN (%i,1,%i) DO @ping >nul -4 -n 1 -w %i %s.%%L', $iStart, $iEnd, $iWait, $sSubNet), '', @SW_HIDE)
;~ 	ConsoleWrite('_PingSubNet - fertig!' & @CRLF)
EndFunc   ;==>_PingSubNet

Func _IsIPv4($sIP)
	Return StringRegExp($sIP, "(((25[0-5])|(2[0-4][0-9])|(1[0-9][0-9])|([1-9]?[0-9]))\.){3}((25[0-5])|(2[0-4][0-9])|(1[0-9][0-9])|([1-9]?[0-9]))")
EndFunc   ;==>_IsIPv4

Func _IsMAC($sMAC)
	Return StringRegExp($sMAC, $g_sMAC_Pattern)
EndFunc   ;==>_IsMAC

Func _Exit()
	TCPShutdown()
EndFunc   ;==>_Exit
